# XorOshiro128Plus

This is an implementation of xoroshiro128+, as detailed at:

http://xoroshiro.di.unimi.it

This is currently the default Rand implementation.


```pony
class ref XorOshiro128Plus is
  Random ref
```

#### Implements

* [Random](random-Random) ref

---

## Constructors

### create

Create with the specified seed. Returned values are deterministic for a
given seed.


```pony
new ref create(
  x: U64 val = 5489,
  y: U64 val = 0)
: XorOshiro128Plus ref^
```
#### Parameters

*   x: [U64](builtin-U64) val = 5489
*   y: [U64](builtin-U64) val = 0

#### Returns

* [XorOshiro128Plus](random-XorOshiro128Plus) ref^

---

## Public Functions

### next

A random integer in [0, 2^64 - 1]


```pony
fun ref next()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### has_next

```pony
fun tag has_next()
: Bool val
```

#### Returns

* [Bool](builtin-Bool) val

---

### u8

```pony
fun ref u8()
: U8 val
```

#### Returns

* [U8](builtin-U8) val

---

### u16

```pony
fun ref u16()
: U16 val
```

#### Returns

* [U16](builtin-U16) val

---

### u32

```pony
fun ref u32()
: U32 val
```

#### Returns

* [U32](builtin-U32) val

---

### u64

```pony
fun ref u64()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### u128

```pony
fun ref u128()
: U128 val
```

#### Returns

* [U128](builtin-U128) val

---

### int

```pony
fun ref int(
  n: U64 val)
: U64 val
```
#### Parameters

*   n: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### real

```pony
fun ref real()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

